Como analisar argumentos de linha de comando com string arbitrária

3

Estou tentando criar um script que tenha uma opção que contenha texto arbitrário (incluindo espaços) entre aspas, o que está sendo difícil de ser pesquisado e implementado.

Basicamente, o comportamento que eu gostaria de ter é docker_build_image.sh -i "image" -v 2.0 --options "--build-arg ARG=value" , esse será um script auxiliar para simplificar as imagens do Docker de controle de versão com o nosso servidor de compilação.

O mais próximo que cheguei de pegar com sucesso o valor --options me dá um erro de getopt, "opção não reconhecida '--build-arg ARG = value'.

O script completo está abaixo

#!/usr/bin/env bash
set -o errexit -o noclobber -o nounset -o pipefail
params="$(getopt -o hi:v: -l help,image:,options,output,version: --name "$0" -- "$@")"
eval set -- "$params"

show_help() {
cat << EOF
Usage: ${0##*/} [-i IMAGE] [-v VERSION] [OPTIONS...]

Builds the docker image with the Dockerfile located in the current directory.

    -i, --image         Required. Set the name of the image.
    --options           Set the additional options to pass to the build command.
    --output            (Default: stdout) Set the output file.
    -v, --version       Required. Tag the image with the version.
    -h, --help          Display this help and exit.
EOF
}

while [[ $# -gt 0 ]]
do
    case $1 in
        -h|-\?|--help)
            show_help
            exit 0
            ;;
        -i|--image)
            if [ -n "$2" ]; then
                IMAGE=$2
                shift
            else
                echo -e "ERROR: '$1' requires an argument.\n" >&2
                exit 1
            fi
            ;;        
        -v|--version)            
            if [ -n "$2" ]; then
                VERSION=$2
                shift
            else
                echo -e "ERROR: '$1' requires an argument.\n" >&2
                exit 1
            fi
            ;;
        --options)
        echo -e "OPTIONS=$2\n"
            OPTIONS=$2
        ;;
        --output)            
            if [ -n "$2" ]; then
                BUILD_OUTPUT=$2
                shift
            else
                BUILD_OUTPUT=/dev/stderr
            fi
        ;;
        --)
            shift
            break
        ;;
        *)
            echo -e "Error: $0 invalid option '$1'\nTry '$0 --help' for more information.\n" >&2
            exit 1
        ;;
    esac
shift
done

echo "IMAGE: $IMAGE"
echo "VERSION: $VERSION"
echo ""

# Grab the SHA-1 from the docker build output
ID=$(docker build ${OPTIONS} -t ${IMAGE}  . | tee $BUILD_OUTPUT | tail -1 | sed 's/.*Successfully built \(.*\)$//')

# Tag our image
docker tag ${ID} ${IMAGE}:${VERSION}
docker tag ${ID} ${IMAGE}:latest
    
por Greg B 19.09.2016 / 18:58

1 resposta

5

Apenas manipule como você manipula os outros que aceitam um argumento ( image e version ). Ou seja, adicione os dois pontos marcando um argumento obrigatório para a cadeia de opção que vai para getopt e escolha o valor de $2 .

Eu acho que o erro que você recebe vem de getopt , já que não é dito que options leva um argumento, e então ele tenta interpretar --build-arg ARG=value como uma opção longa (ele começa com um traço duplo) .

$ cat opt.sh
#!/bin/bash
params="$(getopt -o hv: -l help,options:,version: --name "$0" -- "$@")"
eval set -- "$params"

while [[ $# -gt 0 ]] ; do
    case $1 in
        -h|-\?|--help)
            echo "help"
            ;;
        -v|--version)            
            if [ -n "$2" ]; then
                echo "version: <$2>"
                shift
            fi
            ;;
        --options)            
            if [ -n "$2" ]; then
                echo "options: <$2>"
                shift
            fi
            ;;
    esac
    shift
done

$ bash opt.sh --version 123 --options blah --options "foo bar"
version: <123>
options: <blah>
options: <foo bar>
    
por 19.09.2016 / 19:24